;; minimal/theme.jl

;; Made by me...

(defvar minimal:font (get-font "-b&h-lucida-bold-r-normal-*-*-80-*-*-p-*-iso8859-1"))

(defvar minimal:font-colors (list (get-color "#6e6e6e") (get-color "black")))

(defvar minimal:colors (list (get-color "darkgrey") (get-color "lightgrey")))

(defvar minimal:separator-colors (list (get-color "darkgrey") (get-color "black")))

(defvar minimal:resizer (list (make-image "resizer-inactive.png") (make-image "resizer-active.png") nil nil))

(defun minimal:title-width (w)
  (let
      ((w-width (car (window-dimensions w))))
    (max 0 (min (- w-width 100) (text-width (window-name w))))))

(defvar minimal:frame
 `(
   ;; Bar
   ((background . ,minimal:colors)
    (foreground . ,minimal:font-colors)
    (font . ,minimal:font)
    (text . window-name)
    (top-edge . -11)
    (height . 10)
    (left-edge . 12)
    (width . minimal:title-width)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; Separator
   ((background . ,minimal:separator-colors)
    (top-edge . -12)
    (left-edge . 11)
    (height . 12)
    (width . 1)
    (class menu-button))

   ;; Other frame borders...
   ((background . ,minimal:separator-colors)
    (top-edge . -12)
    (left-edge . 0)
    (height . 1)
    (width . (lambda (w) (+ (minimal:title-width w) 12))))

   ((background . ,minimal:separator-colors)
    (top-edge . -1)
    (left-edge . 0)
    (height . 1)
    (width . (lambda (w) (+ (minimal:title-width w) 12))))

   ((background . ,minimal:separator-colors)
    (left-edge . 0)
    (top-edge . -12)
    (width . 1)
    (height . 12))

   ((background . ,minimal:separator-colors)
    (top-edge . -12)
    (left-edge . (lambda (w) (+ (minimal:title-width w) 12)))
    (width . 1)
    (height . 12))

   ;; Button
   ((background . ,minimal:colors)
    (top-edge . -11)
    (left-edge . 1)
    (height . 10)
    (width . 10)
    (class . menu-button))

   ;; Resizer
   ((background . ,minimal:resizer)
    (bottom-edge . 0)
    (right-edge . 0)
    (height . 15)
    (width . 15)
    (class . bottom-right-corner))

))

(defvar minimal:shaped-frame
 `(
   ;; Bar
   ((background . ,minimal:colors)
    (foreground . ,minimal:font-colors)
    (font . ,minimal:font)
    (text . window-name)
    (top-edge . -11)
    (height . 10)
    (left-edge . 12)
    (width . minimal:title-width)
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; Separator
   ((background . ,minimal:separator-colors)
    (top-edge . -12)
    (left-edge . 11)
    (height . 12)
    (width . 1)
    (class menu-button))

   ;; Other frame borders...
   ((background . ,minimal:separator-colors)
    (top-edge . -12)
    (left-edge . 0)
    (height . 1)
    (width . (lambda (w) (+ (minimal:title-width w) 12))))

   ((background . ,minimal:separator-colors)
    (top-edge . -1)
    (left-edge . 0)
    (height . 1)
    (width . (lambda (w) (+ (minimal:title-width w) 12))))

   ((background . ,minimal:separator-colors)
    (left-edge . 0)
    (top-edge . -12)
    (width . 1)
    (height . 12))

   ((background . ,minimal:separator-colors)
    (top-edge . -12)
    (left-edge . (lambda (w) (+ (minimal:title-width w) 12)))
    (width . 1)
    (height . 12))

   ;; Button
   ((background . ,minimal:colors)
    (top-edge . -11)
    (left-edge . 1)
    (height . 10)
    (width . 10)
    (class . menu-button))
))
 
(defvar minimal:transient-frame
 `(
   ;; Bar
   ((background . ,minimal:colors)
    (foreground . ,minimal:font-colors)
    (font . ,minimal:font)
    (text . window-name)
    (top-edge . -12)
    (height . 12)
    (left-edge . 0)
    (width . minimal:title-width)
    (x-justify . center)
    (y-justify . center)
    (class . title))

    ;; Other frame borders...
   ((background . ,minimal:separator-colors)
    (top-edge . -12)
    (left-edge . 0)
    (height . 1)
    (width . (lambda (w) (minimal:title-width w))))

   ((background . ,minimal:separator-colors)
    (top-edge . -1)
    (left-edge . 0)
    (height . 1)
    (width . (lambda (w) (minimal:title-width w))))

   ((background . ,minimal:separator-colors)
    (left-edge . 0)
    (top-edge . -12)
    (width . 1)
    (height . 12))

   ((background . ,minimal:separator-colors)
    (top-edge . -12)
    (left-edge . (lambda (w) (minimal:title-width w)))
    (width . 1)
    (height . 12))))

(defun minimal:frame-style (w type)
  (cond ((eq type 'shaped)
         'minimal:shaped-frame)
        ((eq type 'unframed)
         'nil-frame)
        ((eq type 'transient)
         'minimal:transient-frame)
        ((eq type 'shaped-transient)
         'minimal:transient-frame)
        (t 'minimal:frame)))

(add-frame-style 'minimal 'minimal:frame-style)

